"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const asyncMap_1 = require("../asyncMap/asyncMap");
const asyncFind_1 = require("../asyncFind/asyncFind");
const mapParallel_1 = require("../mapParallel/mapParallel");
const asyncFilter_1 = require("../asyncFilter/asyncFilter");
const asyncReject_1 = require("../asyncReject/asyncReject");
const foundation_low_1 = require("foundation-low");
class ChainWrapper {
    constructor(value) {
        this.castArray = () => {
            this._chainedPromises.push({
                operation: foundation_low_1.castArray
            });
            return this;
        };
        this.map = (func) => {
            this._chainedPromises.push({
                operation: asyncMap_1.asyncMap,
                func
            });
            return this;
        };
        this.mapParallel = (func) => {
            this._chainedPromises.push({
                operation: mapParallel_1.mapParallel,
                func
            });
            return this;
        };
        this.filter = (func) => {
            this._chainedPromises.push({
                operation: asyncFilter_1.asyncFilter,
                func
            });
            return this;
        };
        this.find = (func) => {
            this._chainedPromises.push({
                operation: asyncFind_1.asyncFind,
                func
            });
            return this;
        };
        this.reject = (func) => {
            this._chainedPromises.push({
                operation: asyncReject_1.asyncReject,
                func
            });
            return this;
        };
        this.value = async () => {
            let index = -1;
            const length = this._chainedPromises.length;
            while (++index < length) {
                const chainedPromises = this._chainedPromises[index];
                this._value = await chainedPromises.operation(this._value, chainedPromises.func);
            }
            return this._value;
        };
        this._value = value;
        this._chainedPromises = [];
    }
}
function asyncChain(value) {
    return new ChainWrapper(value);
}
exports.asyncChain = asyncChain;
//# sourceMappingURL=asyncChain.js.map