"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const asyncChain_1 = require("./asyncChain");
const chai_1 = require("chai");
async function asyncFunc(item) {
    return await new Promise((resolve) => {
        resolve(item.id === 2);
    });
}
describe("chain", () => {
    it("should chain functions", async () => {
        const array = [
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            },
            {
                id: 3,
                a: true
            }
        ];
        const result = await asyncChain_1.asyncChain(array)
            .find((item) => item.id === 2)
            .castArray()
            .map("id")
            .value();
        chai_1.expect(result).to.eql([2]);
    });
    it("should chain async functions", async () => {
        const array = [
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            },
            {
                id: 3,
                a: true
            }
        ];
        const result = await asyncChain_1.asyncChain(array)
            .find(asyncFunc)
            .castArray()
            .map("id")
            .value();
        chai_1.expect(result).to.eql([2]);
    });
});
//# sourceMappingURL=asyncChain.spec.js.map