"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const filterObject_1 = require("../helpers/filterObject");
const getPredicateFunction_1 = require("../helpers/getPredicateFunction");
async function doFilter(collection, predicate) {
    let index = -1;
    let resIndex = 0;
    const length = collection.length;
    const result = [];
    while (++index < length) {
        const value = collection[index];
        if (await predicate(value, index, collection)) {
            result[resIndex++] = value;
        }
    }
    return result;
}
function asyncFilter(collection, predicate) {
    const predicateFunc = getPredicateFunction_1.getPredicateFunction(predicate);
    const func = Array.isArray(collection) ? doFilter : filterObject_1.filterObject;
    return func(collection, predicateFunc);
}
exports.asyncFilter = asyncFilter;
//# sourceMappingURL=asyncFilter.js.map