"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const getPredicateFunction_1 = require("../helpers/getPredicateFunction");
async function asyncFind(collection, predicate) {
    const asyncFunc = getPredicateFunction_1.getPredicateFunction(predicate);
    let index = -1;
    const length = collection.length;
    let result = undefined;
    while (++index < length) {
        if (await asyncFunc(collection[index])) {
            result = collection[index];
            break;
        }
    }
    return result;
}
exports.asyncFind = asyncFind;
//# sourceMappingURL=asyncFind.js.map