"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const asyncMap_1 = require("./asyncMap");
async function asyncFunc(n) {
    return await new Promise((resolve) => {
        resolve(String(n));
    });
}
describe("Map", () => {
    const array = [1, 2];
    it("should map values in collection to a new array", async () => {
        const object = {
            a: 1,
            b: 2
        };
        const expected = ["1", "2"];
        chai_1.expect(await asyncMap_1.asyncMap(array, String)).to.eql(expected);
        chai_1.expect(await asyncMap_1.asyncMap(object, String)).to.eql(expected);
    });
    it("should map async values in collection to a new array", async () => {
        const object = {
            a: 1,
            b: 2
        };
        const expected = ["1", "2"];
        chai_1.expect(await asyncMap_1.asyncMap(array, asyncFunc)).to.eql(expected);
        chai_1.expect(await asyncMap_1.asyncMap(object, asyncFunc)).to.eql(expected);
    });
    it("should work with string shorthands", async () => {
        const objects = [
            {
                a: "x"
            },
            {
                a: "y"
            }
        ];
        const result = await asyncMap_1.asyncMap(objects, "a");
        chai_1.expect(result).to.eql(["x", "y"]);
    });
});
//# sourceMappingURL=asyncMap.spec.js.map