"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const asyncFilter_1 = require("../asyncFilter/asyncFilter");
const getPredicateFunction_1 = require("../helpers/getPredicateFunction");
const filterObject_1 = require("../helpers/filterObject");
function negate(predicate) {
    return async (func) => {
        return !(await predicate(func));
    };
}
function asyncReject(collection, predicate) {
    const predicateFunc = getPredicateFunction_1.getPredicateFunction(predicate);
    const func = Array.isArray(collection) ? asyncFilter_1.asyncFilter : filterObject_1.filterObject;
    return func(collection, negate(predicateFunc));
}
exports.asyncReject = asyncReject;
//# sourceMappingURL=asyncReject.js.map