"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const asyncReject_1 = require("./asyncReject");
async function asyncFunc(item) {
    return await new Promise((resolve) => {
        resolve(item.id === 2);
    });
}
describe("reject", () => {
    it("reject with async function", async () => {
        const array = [
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            },
            {
                id: 3,
                a: true
            }
        ];
        const result = await asyncReject_1.asyncReject(array, asyncFunc);
        chai_1.expect(result).to.eql([
            {
                id: 1,
                a: false
            },
            {
                id: 3,
                a: true
            }
        ]);
    });
    it("reject with string shorthand", async () => {
        const array = [
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            },
            {
                id: 3,
                a: true
            }
        ];
        chai_1.expect(await asyncReject_1.asyncReject(array, "a")).to.eql([
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            }
        ]);
    });
    it("reject with object shorthand", async () => {
        const array = [
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            },
            {
                id: 3,
                a: true
            },
            {
                id: 2,
                a: true,
                foobar: "bar"
            }
        ];
        const result = await asyncReject_1.asyncReject(array, {
            id: 2,
            a: true
        });
        chai_1.expect(result).to.eql([
            {
                id: 1,
                a: false
            },
            {
                id: 2,
                a: false
            },
            {
                id: 3,
                a: true
            }
        ]);
    });
});
//# sourceMappingURL=asyncReject.spec.js.map