"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const asyncForEach_1 = require("../asyncForEach/asyncForEach");
async function filterObject(object, predicate) {
    const keys = Object(object).keys(object);
    const result = [];
    await asyncForEach_1.asyncForEach(keys, async (key) => {
        const value = object[key];
        if (await predicate(value, key, object)) {
            result.push(value);
        }
    });
    return result;
}
exports.filterObject = filterObject;
//# sourceMappingURL=filterObject.js.map