"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const foundation_low_1 = require("foundation-low");
function getPredicateFunction(predicate) {
    switch (true) {
        case foundation_low_1.isFunction(predicate):
            return predicate;
        case foundation_low_1.isObject(predicate):
            return (item) => {
                let index = -1;
                const keys = Object.keys(predicate);
                const length = keys.length;
                while (++index < length) {
                    const key = keys[index];
                    if (!item[key] || item[key] !== predicate[key]) {
                        return false;
                    }
                }
                return true;
            };
        case foundation_low_1.isString(predicate):
            return (item) => {
                if (item[predicate] === true) {
                    return true;
                }
                return false;
            };
        default:
            return predicate;
    }
}
exports.getPredicateFunction = getPredicateFunction;
//# sourceMappingURL=getPredicateFunction.js.map